import { HttpClient } from '@angular/common/http';
import { EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { IndexedDbService } from './services';
import * as i0 from "@angular/core";
export declare class NgxHttpGetShellComponent implements OnInit, OnChanges, OnDestroy {
    private _storage;
    private _http;
    /**
     * The URL to fetch data from. It will be used as the key from the cache.
     */
    url: string;
    /**
     * Max Stale duration in milliseconds, default is 0, which means no cache.
     */
    maxStale: number;
    /**
     * The processor for the fetched data before it is emitted.
     */
    dataProcessor?: (data: any) => any;
    /**
     * The error handler for the data fetching.
     */
    errorHandler?: (err: any) => void;
    /**
     * The template reference will be used to render the fetched data.
     */
    templateRef: TemplateRef<any>;
    /**
     * Emitted when the data is loaded and processed.
     */
    dataLoaded: EventEmitter<any>;
    data$: BehaviorSubject<any>;
    private _url$;
    private _sub?;
    constructor(_storage: IndexedDbService, _http: HttpClient);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    private _subscribeToUrlChange;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxHttpGetShellComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxHttpGetShellComponent, "ngx-http-get-shell", never, { "url": "url"; "maxStale": "maxStale"; "dataProcessor": "dataProcessor"; "errorHandler": "errorHandler"; "templateRef": "templateRef"; }, { "dataLoaded": "dataLoaded"; }, never, never, false>;
}
